class DicePlayer {
    private String name;
    private int nbDiceRolls;
    private int totalValue;

    public DicePlayer(String name) {
        this.name = name;
        this.nbDiceRolls = 0;
        this.totalValue = 0;
    }

    public String toString() {
        return this.name + ": " + this.totalValue + " points en " + this.nbDiceRolls + " coups.";
    }

    public void play (Dice aDice) {
        aDice.roll();
        this.nbDiceRolls++;
        this.totalValue += aDice.getValue();
    }

    public void playUntil (Dice aDice, int objective) {
        do {
            this.play(aDice);
        } while (this.totalValue < objective);
    }

    public boolean isWinner (DicePlayer other) {
        if (this.nbDiceRolls < other.nbDiceRolls) {
            return true;
        } else if (this.nbDiceRolls == other.nbDiceRolls) {
            return this.totalValue > this.totalValue;
        }
        return false;
    }

    /* GETTERS */
    public String getName() {
        return this.name;
    }

    public int getDiceRolls() {
        return this.nbDiceRolls;
    }

    public int getTotalValue() {
        return this.totalValue;
    }

}
