import java.util.Scanner;

public class TwoDicePlayerGame {

    private DicePlayer player1;
    private DicePlayer player2;

    public TwoDicePlayerGame(DicePlayer player1, DicePlayer player2) {
        this.player1 = player1;
        this.player2 = player2;
    }
    
    public void play (Dice aDice, int objective) {
        player1.playUntil(aDice, objective);
        player2.playUntil(aDice, objective);
    }

    public DicePlayer getWinner() {
        if (this.player1.isWinner(this.player2)) {
            return this.player1;
        }
        return this.player2;
    }

    public static void main (String[] args) {

        Scanner scanner = new Scanner(System.in);
        
        System.out.print("Joueur 1, entrez votre nom: ");
        String player1Name = scanner.nextLine();

        System.out.print("Joueur 2, entrez votre nom: ");
        String player2Name = scanner.nextLine();

        scanner.close();

        TwoDicePlayerGame game = new TwoDicePlayerGame(new DicePlayer(player1Name), new DicePlayer(player2Name));
        Dice dice = new Dice(6);
        game.play(dice, 20);

        System.out.println("Félicitations à " + game.getWinner().getName() + " qui a gagné!");
        
    }

}
