package tp03.ex01;

import java.time.LocalDate;
import java.time.chrono.ChronoLocalDate;
import java.util.Random;
import java.time.Period;

public class UseLocalDate {

	public static boolean inArray(int[] array, int value) {
		for (int i = 0; i < array.length; i++) {
			if (array[i] == value) {
				return true;
			}
		}
		return false;
	}

	public static void main(String[] args) {

		LocalDate d1 = LocalDate.now();
		LocalDate d2 = LocalDate.of(2006, 11, 12);

		// Random number manipulation for d3 date
		Random random = new Random();
		LocalDate d3;

		int year = LocalDate.now().getYear() - random.nextInt(30) - 1;
		int month = random.nextInt(12) + 1;
		int dayBound;

		if (inArray(new int[]{1, 3, 5, 7, 8, 10, 12}, month)) {
			dayBound = 31;
		} else if (month == 2) {
			if (year % 4 == 0 && year % 100 != 0) {
				dayBound = 29;
			} else {
				dayBound = 28;
			}
		} else {
			dayBound = 30;
		}


		d3 = LocalDate.of(year, month, random.nextInt(dayBound) + 1);

		System.out.println("d3 is " + d3);

		if (d2.compareTo(d3) < 0) {
			System.out.println("Older date is " + d2);
		} else {
			System.out.println("Older date is " + d3);
		}

		// d4 is LocalDate 7 days after today's date 
		LocalDate d4 = d1.plusDays(7);

		System.out.println("In 1 week we@'ll be on " + d4);

		Period periode = d2.until(ChronoLocalDate.from(d1));
		System.out.println(periode.getYears() + " ans, " + periode.getMonths() + " mois, et " + periode.getDays() + " jours entre " + d1 + " et " + d2);

	}

}